---
title: DOMMatrix (WebKitCSSMatrix)
slug: Web/API/DOMMatrix
tags:
  - API
  - DOMMatrix
  - Experimental
  - Geometry
  - Geometry Interfaces
  - Interface
  - Reference
  - matrix
---
<p>{{APIRef("Geometry Interfaces")}}</p>

<p><span class="seoSummary">The <code><strong>DOMMatrix</strong></code> interface represents 4×4 matrices, suitable for 2D and 3D operations including rotation and translation. It is a mutable version of the {{domxref("DOMMatrixReadOnly")}} interface.</span></p>

<p><code><strong>WebKitCSSMatrix</strong></code> is an alias to <code><strong>DOMMatrix</strong></code>.</p>

<p>This interface should be available inside <a href="/en-US/docs/Web/API/Web_Workers_API">web workers</a>, though some implementations don't allow it yet.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("DOMMatrix.DOMMatrix","DOMMatrix()")}}</dt>
 <dd>Creates and returns a new <code>DOMMatrix</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface inherits properties from {{domxref("DOMMatrixReadOnly")}}, though some of these properties are altered to be mutable.</em></p>

<dl>
 <dt><code>is2D</code> {{ReadOnlyInline}}</dt>
 <dd>A Boolean flag whose value is <code>true</code> if the matrix was initialized as a 2D matrix. If <code>false</code>, the matrix is 3D.</dd>
 <dt><code>isIdentity</code> {{ReadOnlyInline}}</dt>
 <dd>A Boolean whose value is <code>true</code> if the matrix is the {{interwiki("wikipedia", "identity matrix")}}. The identity matrix is one in which every value is <code>0</code> <em>except</em> those on the main diagonal from top-left to bottom-right corner (in other words, where the offsets in each direction are equal).</dd>
 <dt><code>m11</code>, <code>m12</code>, <code>m13</code>, <code>m14</code>, <code>m21</code>, <code>m22</code>, <code>m23</code>, <code>m24</code>, <code>m31</code>, <code>m32</code>, <code>m33</code>, <code>m34</code>, <code>m41</code>, <code>m42</code>, <code>m43</code>, <code>m44</code></dt>
 <dd>Double-precision floating-point values representing each component of a 4×4 matrix, where <code>m11</code> through <code>m14</code> are the first column, <code>m21</code> through <code>m24</code> are the second column, and so forth.</dd>
 <dt><code>a</code>, <code>b</code>, <code>c</code>, <code>d</code>, <code>e</code>, <code>f</code></dt>
 <dd>
 <p>Double-precision floating-point values representing the components of a 4×4 matrix which are required in order to perform 2D rotations and translations. These are aliases for specific components of a 4×4 matrix, as shown below.</p>

 <table class="standard-table">
  <thead>
   <tr>
    <th scope="col"><code>2D</code></th>
    <th scope="col"><code>3D equivalent</code></th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td><code>a</code></td>
    <td><code>m11</code></td>
   </tr>
   <tr>
    <td><code>b</code></td>
    <td><code>m12</code></td>
   </tr>
   <tr>
    <td><code>c</code></td>
    <td><code>m21</code></td>
   </tr>
   <tr>
    <td><code>d</code></td>
    <td><code>m22</code></td>
   </tr>
   <tr>
    <td><code>e</code></td>
    <td><code>m41</code></td>
   </tr>
   <tr>
    <td><code>f</code></td>
    <td><code>m42</code></td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface includes the following methods, as well as the methods it inherits from {{domxref("DOMMatrixReadOnly")}}.</em></p>

<dl>
 <dt>{{domxref("DOMMatrix.invertSelf()")}}</dt>
 <dd>Modifies the matrix by inverting it. If the matrix can't be inverted, its components are all set to <code>NaN</code>, and {{domxref("DOMMatrix.is2D", "is2D")}} returns <code>false</code>.</dd>
 <dt>{{domxref("DOMMatrix.multiplySelf()")}}</dt>
 <dd>Modifies the matrix by post-multiplying it with the specified <code>DOMMatrix</code>. This is equivalent to the dot product <code>A⋅B</code>, where matrix <code>A</code> is the source matrix and <code>B</code> is the matrix given as an input to the method. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.preMultiplySelf()")}}</dt>
 <dd>Modifies the matrix by pre-multiplying it with the specified <code>DOMMatrix</code>. This is equivalent to the dot product <code>B⋅A</code>, where matrix <code>A</code> is the source matrix and <code>B</code> is the matrix given as an input to the method. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.translateSelf()")}}</dt>
 <dd>Modifies the matrix by applying the specified vector. The default vector is <code>[0, 0, 0]</code>. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.scaleNonUniformSelf()")}} {{obsolete_inline}}</dt>
 <dd>Modifies the matrix by applying the specified scaling on the X, Y, and Z axes, centered at the given origin. By default, the Y and Z axes' scaling factors are both <code>1</code>, but the scaling factor for X must be specified. The default origin is <code>(0, 0, 0)</code>. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.scaleSelf()")}}</dt>
 <dd>Modifies the matrix by applying the specified scaling factors, with the center located at the specified origin. Also returns itself. By default, the scaling factor is <code>1</code> for all three axes, and the origin is <code>(0, 0, 0)</code>. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.scale3dSelf()")}}</dt>
 <dd>Modifies the matrix by applying the specified scaling factor to all three axes, centered on the given origin. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.rotateSelf()")}}</dt>
 <dd>Modifies the matrix by rotating itself around each axis by the specified number of degrees. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.rotateAxisAngleSelf()")}}</dt>
 <dd>Modifies the matrix by rotating it by the specified angle around the given vector. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.rotateFromVectorSelf()")}}</dt>
 <dd>Modifies the matrix by rotating it by the angle between the specified vector and <code>(1, 0)</code>. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.setMatrixValue()")}}</dt>
 <dd>Replaces the contents of the matrix with the matrix described by the specified transform or transforms. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.skewXSelf()")}}</dt>
 <dd>Modifies the matrix by applying the specified skew transformation along the X-axis. Returns itself.</dd>
 <dt>{{domxref("DOMMatrix.skewYSelf()")}}</dt>
 <dd>Modifies the matrix by applying the specified skew transformation along the Y-axis. Returns itself.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<p><em>This interface inherits methods from {{domxref("DOMMatrixReadOnly")}}.</em></p>

<dl>
 <dt>{{domxref("DOMMatrix.fromFloat32Array", "fromFloat32Array()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an array of single-precision (32-bit) floating-point values. If the array has six values, the result is a 2D matrix; if the array has 16 values, the result is a 3D matrix. Otherwise, a <code>TypeError</code> exception is thrown.</dd>
 <dt>{{domxref("DOMMatrix.fromFloat64Array", "fromFloat64Array()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an array of double-precision (64-bit) floating-point values. If the array has six values, the result is a 2D matrix; if the array has 16 values, the result is a 3D matrix. Otherwise, a <code>TypeError</code> exception is thrown.</dd>
 <dt>{{domxref("DOMMatrix.fromMatrix", "fromMatrix()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an existing matrix or a {{domxref("DOMMatrixInit")}} dictionary which provides the values for its properties.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The matrix defined by the <code>DOMMatrix</code> interface is comprised of four rows of four columns each. While it's beyond the scope of this article to explain the mathematics involved, this 4×4 size is enough to describe any transformation you might apply to either 2D or 3D geometries.</p>

<div style="max-width: 42rem; border: 1px solid #bbb; padding: 0.5rem; margin-bottom: 1em;">
<div style="margin: 0 auto; max-width: 25rem;">
<figure><math display="block"><semantics><mrow><mo>[</mo><mtable rowspacing="0.5ex"><mtr><mtd><msub><mi>m</mi><mn>11</mn></msub></mtd><mtd><msub><mi>m</mi><mn>21</mn></msub></mtd><mtd><msub><mi>m</mi><mn>31</mn></msub></mtd><mtd><msub><mi>m</mi><mn>41</mn></msub></mtd></mtr><mtr><mtd><msub><mi>m</mi><mn>12</mn></msub></mtd><mtd><msub><mi>m</mi><mn>22</mn></msub></mtd><mtd><msub><mi>m</mi><mn>32</mn></msub></mtd><mtd><msub><mi>m</mi><mn>42</mn></msub></mtd></mtr><mtr><mtd><msub><mi>m</mi><mn>13</mn></msub></mtd><mtd><msub><mi>m</mi><mn>23</mn></msub></mtd><mtd><msub><mi>m</mi><mn>33</mn></msub></mtd><mtd><msub><mi>m</mi><mn>43</mn></msub></mtd></mtr><mtr><mtd><msub><mi>m</mi><mn>14</mn></msub></mtd><mtd><msub><mi>m</mi><mn>24</mn></msub></mtd><mtd><msub><mi>m</mi><mn>34</mn></msub></mtd><mtd><msub><mi>m</mi><mn>44</mn></msub></mtd></mtr></mtable><mo>]</mo></mrow><annotation encoding="TeX">\left [ \begin{matrix} m_{11} &amp; m_{21} &amp; m_{31} &amp; m_{41} \\ m_{12} &amp; m_{22} &amp; m_{32} &amp; m_{42} \\ m_{13} &amp; m_{23} &amp; m_{33} &amp; m_{43} \\ m_{14} &amp; m_{24} &amp; m_{34} &amp; m_{44} \end{matrix} \right ]</annotation></semantics></math>

<figcaption><strong>The positions of the 16 elements (m<sub>11</sub> through m<sub>44</sub>)</strong> which comprise the 4×4 abstract matrix.</figcaption>
</figure>
</div>
</div>

<p>The <code>DOMMatrix</code> interface is designed with the intent that it will be used for all matrices within markup, supplanting the {{domxref("SVGMatrix")}} and {{domxref("CSSMatrix")}} interfaces.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Geometry Interfaces', '#DOMMatrix', 'DOMMatrix') }}</td>
   <td>{{ Spec2('Geometry Interfaces') }}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMMatrix")}}</p>

<p>{{Compat("api.WebKitCSSMatrix")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Its non-modifiable counterpart, {{domxref("DOMMatrixReadOnly")}}</li>
 <li>{{domxref("SVGMatrix")}}, the SVG matrix intended to be superseded by {{domxref("DOMMatrix")}}</li>
</ul>
